let serverTime = getLocalTime();
let setTs = [];

syncTime(serverTime);

function initSyncTime(time) {
  syncTime(time);
}

function getLocalTime() {
  const time = localStorage.getItem("st");
  const unvalidVals = ["Infinity", "NaN", "null", "undefined"];
  return unvalidVals.includes(time) ? Date.now() : time * 1;
}

function addSetTime(action, time = 1 * 1000) {
  setTs.push(setTimeout(action, time));
}

function clearSetTs() {
  if (!setTs.length) return;
  setTs.forEach(t => clearTimeout(t));
  setTs = [];
}

function syncTime(time) {
  clearSetTs();
  serverTime = time;
  localStorage.setItem("st", time);
  addSetTime(() => {
    syncTime(serverTime + 1000);
  });
}

function fetchTime() {
  return serverTime;
}

export { initSyncTime, fetchTime };
